using System;
using System.Collections.Generic;
using System.Data.SqlClient;

namespace NihonUnisys.ParadiseTwo
{
    internal static class AccountDataAccessObject
    {
        internal static List<string> GetNames(
            SqlTransaction sqlTransaction)
        {
            string sql = "select Name from Account";

            List<string> l = new List<string>();

            using (SqlCommand sc = 
                new SqlCommand(sql, sqlTransaction.Connection, sqlTransaction))
            {
                using (SqlDataReader dr = sc.ExecuteReader())
                {
                    while (dr.NextResult())
                    {
                        l.Add(Convert.ToString(dr.GetValue(0)));
                    }
                }
            }

            return l;
        }

        internal static string GetNameByAccountNumber(
            SqlTransaction sqlTransaction,
            string accountNumber)
        {
            string sql = string.Format(
                "select Name from Account " +
                "where AccountNumber = '{0}'",
                accountNumber);

            using (SqlCommand sc =
                new SqlCommand(sql, sqlTransaction.Connection, sqlTransaction))
            {
                return Convert.ToString(sc.ExecuteScalar());
            }
        }

        internal static string GetAccountNumberByPhoneNumber(
            SqlTransaction sqlTransaction, 
            string phoneNumber)
        {
            string sql = string.Format(
                "select AccountNumber from Account " +
                "where PhoneNumber = '{0}'",
                phoneNumber);

            using (SqlCommand sc = 
                new SqlCommand(sql, sqlTransaction.Connection, sqlTransaction))
            {
                return Convert.ToString(sc.ExecuteScalar());
            }
        }

        internal static string GetAccountNumberByPhoneNumberWithUpdLock(
            SqlTransaction sqlTransaction, 
            string phoneNumber)
        {
            string sql = string.Format(
                "select AccountNumber from Account with (updlock) " + 
                "where PhoneNumber = '{0}'",
                phoneNumber);

            using (SqlCommand sc = 
                new SqlCommand(sql, sqlTransaction.Connection, sqlTransaction))
            {
                return Convert.ToString(sc.ExecuteScalar());
            }
        }

        internal static void UpdateNameByAccountNumber(
            SqlTransaction sqlTransaction, 
            string name, string accountNumber)
        {
            string sql = string.Format(
                "update Account set Name = '{0}' " + 
                "where AccountNumber = '{1}'",
                name, accountNumber);

            using (SqlCommand sc = 
                new SqlCommand(sql, sqlTransaction.Connection, sqlTransaction))
            {
                sc.ExecuteNonQuery();
            }
        }
    }
}
