using System;
using System.Data.SqlClient;

namespace NihonUnisys.ParadiseTwo
{
    internal static class DatabaseUtility
    {
        internal static void AllowSnapshotIsolation()
        {
            string sql = 
                "alter database SimpleBank set allow_snapshot_isolation on";

            using (SqlConnection scon = new SqlConnection(
                Properties.Settings.Default.SimpleBankConnectionString))
            {
                scon.Open();

                using (SqlCommand scom = new SqlCommand(sql, scon))
                {
                    scom.ExecuteNonQuery();
                }
            }
        }

        internal static void SetReadCommittedSnapshotOn()
        {
            string sql = 
                "alter database SimpleBank set read_committed_snapshot on";

            using (SqlConnection scon = new SqlConnection(
                Properties.Settings.Default.SimpleBankConnectionString))
            {
                scon.Open();

                using (SqlCommand scom = new SqlCommand(sql, scon))
                {
                    scom.ExecuteNonQuery();
                }
            }
        }

        internal static void SetReadCommittedSnapshotOff()
        {
            string sql = 
                "alter database SimpleBank set read_committed_snapshot off";

            using (SqlConnection scon = new SqlConnection(
                Properties.Settings.Default.SimpleBankConnectionString))
            {
                scon.Open();

                using (SqlCommand scom = new SqlCommand(sql, scon))
                {
                    scom.ExecuteNonQuery();
                }
            }
        }
    }
}
