using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Data.SqlClient;

namespace NihonUnisys.ParadiseTwo
{
    public static class GetAccountNamesWithReadCommitted
    {
        public static ReadOnlyCollection<string> Compute()
        {
            ReadOnlyCollection<string> roc = null;

            using (SqlConnection sc = new SqlConnection(
                Properties.Settings.Default.SimpleBankConnectionString))
            {
                sc.Open();

                using (SqlTransaction st = 
                    sc.BeginTransaction(IsolationLevel.ReadCommitted))
                {
                    try
                    {
                        roc = new ReadOnlyCollection<string>(
                            AccountDataAccessObject.GetNames(st));

                        st.Commit();
                    }
                    catch
                    {
                        st.Rollback();
                        throw;
                    }
                }
            }

            return roc;
        }
    }
}
