using System;
using System.Data.SqlClient;
using System.Transactions;

namespace NihonUnisys.ParadiseTwo
{
    public static class TableAdapterPlusTransactionScopeWithReadCommitted
    {
        public static void Compute()
        {
            TransactionOptions to = new TransactionOptions();
            to.IsolationLevel = IsolationLevel.ReadCommitted;

            using (SimpleBankDataSet ds = new SimpleBankDataSet())
            {
                using (TransactionScope ts = new TransactionScope(TransactionScopeOption.Required, to))
                {
                    using (SimpleBankDataSetTableAdapters.AccountTableAdapter ta = new NihonUnisys.ParadiseTwo.SimpleBankDataSetTableAdapters.AccountTableAdapter())
                    {
                        ta.Fill(ds.Account);
                    }

                    using (SimpleBankDataSetTableAdapters.AccountDetailTableAdapter ta = new NihonUnisys.ParadiseTwo.SimpleBankDataSetTableAdapters.AccountDetailTableAdapter())
                    {
                        ta.Fill(ds.AccountDetail);
                    }

                    ds.Account[0].Name = "ǎi";
                    ds.AccountDetail[0].Note = "{jVX";

                    using (SimpleBankDataSetTableAdapters.AccountTableAdapter ta = new NihonUnisys.ParadiseTwo.SimpleBankDataSetTableAdapters.AccountTableAdapter())
                    {
                        ta.Update(ds.Account);
                    }

                    using (SimpleBankDataSetTableAdapters.AccountDetailTableAdapter ta = new NihonUnisys.ParadiseTwo.SimpleBankDataSetTableAdapters.AccountDetailTableAdapter())
                    {
                        ta.Update(ds.AccountDetail);
                    }

                    //  READ_COMMITTED_SNAPSHOT̏ꍇATransactionScopeiĂO͏oȂB
                }
            }
        }
    }
}
